/* argparse.c 
 *   argument parsing routine to break down a command line
 *   into individual arguments 
 *   (currently does not handle wildcard matching)
 *   Project JakeDev for Computer Science House
 *   December 11th, 1990
 *   by Frank Barrus 
 */


#include "types.h"

#define  is_num(x)    ((x >= '0' && x <= '9') || x == '-')
#define  is_word(x)   ((x >= 'A' && x <= 'Z') || (x >= 'a' && x <= 'z'))
#define  is_punc(x)   ((x) && index("!@#$%^*?+-/\\.:\"",x))
#define  is_sep(x)    ((x) && index("&()[]<>{}|x`',=;",x))
#define  is_sym(x)    (is_num(x) || is_word(x) || is_punc(x))


int argnext(wbuf, str, pos)
char *wbuf;
char *str;
int  pos;
{
boolean inquote = FALSE;
int wpos = 0;
   while(str[pos] == ' ')
      pos++;
   while(inquote || is_sym(str[pos])) {
      if(str[pos]=='"') {
         inquote = !inquote;
         pos++;
      }
      if(str[pos]=='\\') 
         pos++;
      wbuf[wpos++] = str[pos++];
   } 
/* might be problem if str[pos] = 0 */
   if(is_sep(str[pos]) && (!wpos))
      wbuf[wpos++] = str[pos++];
   wbuf[wpos] = '\0';
   return(pos);
}

int argparse(str,argv,argbuf,trans)
char *str;
char **argv;
char *argbuf;
int  trans; /* to be used for translation tables in the future */
{
int p=0;
int n=0;
int i=0;
   do {
      argv[n] = &argbuf[i];
      p=argnext(argv[n],str,p);
      i += strlen(argv[n])+1;
   } while(*argv[n++]);
   return(n-1);
}

