/* kshell.c
 *   main kernel shell
 *   author: Frank Barrus
 */

#include "types.h"


/* current revision:  0.1 */
#define ver_major 0
#define ver_minor 1

typedef struct envnode {
	char name[10];
	char val[40];
	struct envnode *next;
} ENVNODE;

struct rel_node {
	char *str;
	int  (*fptr)();
};

struct assoctab {
	int	size;
	struct rel_node rel[80];
};

struct job {
	int	argc;
	char	*argv[20];
	char	argbuf[256];
	int	(*fptr)();
	int	pid;
	int	jnum;
	struct assoctab envtab;
};

#define DEV 4

#define MAXJOBS 3
static int jobpid[MAXJOBS];
static char jobcmd[MAXJOBS][80];
static uint32 cwd;
static wdname[100];
ENVNODE *env;
ENVNODE *alias;
char sb[512];



match(buf,i,str)
char *buf;
int i;
char *str;
{
  buf = &buf[i];
  while(*str && *buf == *str) {
     str++;
     buf++;
  }
  return(*str == 0);
}


	
blah(x)
int x;
{
   printf("arg: %d\n", x);
   x = 0;
   while(x < 2000) {
     putchar(96+(x++ & 15));
   }
   for(x=0; x<1000000; x++); 
   puts("done with forked proc\n");
}


khostid(argc,argv)
int argc;
char **argv;
{
   printf("Sorry, I can't find the internet\n");
}

khostname(argc,argv)
int argc;
char **argv;
{
   printf("jake\n");
}


kclear(argc,argv)
int argc;
char **argv;
{
  puts("\033[2J\033[H");
}


nosuch(str)
char *str;
{
   printf("%s: No such file or directory\n",str);
}


kpwd(argc,argv)
int argc;
char **argv;
{
  printf("%s\n",wdname);
}


kcd(argc,argv)
int argc;
char **argv;
{
uint32 wd;
/*
  if ((wd = kname(cwd,argv[1])) == ER_NOATTR)
     nosuch(argv[1]);
  else {
     cwd = wd; 
     strcpy(wdname,argv[1]);
  }
*/
}


kmkdir(argc,argv)
int argc;
char **argv;
{
/*
  mkdir(cwd,argv[1]);
*/
}

kmv(argc,argv)
int argc;
char **argv;
{
uint32 oid;
/*
  oid = getattr(cwd,argv[1]);
  delattr(cwd,argv[1]);
  setattr(cwd,argv[2],oid);
*/
}

klink(argc,argv)
int argc;
char **argv;
{
/*
  setattr(cwd,argv[2],atoi(argv[1]));
*/
}

kls(argc,argv)
int argc;
char **argv;
{
char *atid;
uint32 index;
int i;
char *str;
boolean sw[128];
/*
   i = 128;
   while(i--) {
      sw[i] = FALSE;
   }
   i = 1;
   while(i < argc && argv[i][0] == '-') {
      str = argv[i];
      while(*(++str)) {
         sw[*str] = TRUE;
      }
      i++;
   }
   if (i == argc) {
      argc++;
      argv[i] = "*";
   }
   while(i < argc) {
      index = 0;
      while(atid = (char*)fcall(cwd,F_GETATID,argv[i],&index)) {
         if(sw['i']) 
            printf("%8x ",getattr(cwd,atid));
         if(sw['l']) {
            printf("drwxr-x--x  1 %-9s","root");
            if(sw['g'])
               printf("%-9s","sys");
            printf("%8d Jan 28 01:55 ",512);
         }
         if(sw['i']) {
            printf("%-11s",atid);
         } else
            printf("%-16s",atid);
         if(sw['l'])
            putchar('\n');
      }
      i++;
   }
   putchar('\n');
*/
}

krm(argc,argv)
int argc;
char **argv;
{
int i = 0;
/*
  while(++i < argc) {
     if(delattr(cwd,argv[i]) == ER_NOATTR)
       puts("rm: %s nonexistant\n");
  }
*/
}

kps(argc,argv)
int argc;
char **argv;
{
  puts("ps: no process directory\n");
}


kcat(argc,argv)
int argc;
char **argv;
{
int n;
char buf[80];
  n=creadline(buf,79,'\n');
  while(n>=0) {
     puts(buf);
     putchar('\n');
     n=creadline(buf,79,'\n');
  }
}


ksleep(argc, argv)
int argc;
char **argv;
{
int i;
  i = atoi(argv[1]); 
  printf("sleeping for %d ticks\n", i);
  while(i--); 
}


kecho(argc, argv)
int argc;
char **argv;
{
int i = 0;
boolean nl = TRUE;
   if(strcmp(argv[1],"-n")==0) {
      nl = FALSE;
      i++;
   }
   while(++i < argc) {
      puts(argv[i]);
      putchar(' ');
   }
   if(nl)
      putchar('\n');
}



kwho(argc,argv)
int argc;
char **argv;
{
   puts("User\ttty\tWhat\n");
   puts("wrc\t00\twho\n");
}


kfinger(argc,argv)
int argc;
char **argv;
{
   puts("Login\tName\t\t\tTTY\n");
   puts("wrc\tWarren Carithers\t00\n");
}


knotimp(argc,argv)
int argc;
char **argv;
{
static int i;
  i++;
  switch(i) {
     case 1:  puts("Yeah, RIGHT.\n"); break;
     case 2:  puts("Gimme a break.\n"); break;
     case 3:  puts("Huh? Am I supposed to understand that?\n"); break;
     case 4:  puts("Maybe next year...\n"); break;
     case 5:  puts("You want it, you write it\n"); break;
     case 6:  puts("Give me a hard drive, and I'll see what I can do.\n");
              break;
     case 7:  puts("Not now, I've got a headache\n"); break;
     case 8:  puts("HA!!! What a laugh.\n"); break;
     case 9:  puts("What am I? Your personal slave?\n"); break;
     default:
       puts("You have GOT to be kidding.\n");
       i = 0;
  }
}


kmail(argc,argv)
int argc;
char **argv;
{
  if(argc > 1)
     puts("No such user\n");
  else {
     puts("You have no mail\n");
  }
}


kjobs(argc,argv)
int argc;
char **argv;
{
int i;
boolean found = FALSE;
   for(i=0; i<MAXJOBS; i++)
      if(jobpid[i]) {
         printf("[%d] %d %s\n",i+1,jobpid[i],jobcmd[i]); 
         found = TRUE;
      }
   if(!found) {
      puts("Sorry, no jobs are running right now. But at least I CAN\n");
      puts("multitask.  That's better than MSDOS can say.\n");
   }
}


kfork(argc,argv)
int argc;
char **argv;
{
int pid;
/*
   puts("This is a test of tfork()\n");
   if (pid=tfork())
      printf("This is process #%d\n",pid);
   else
      printf("This is the child process\n");
   puts("Now both are running at the same time.\n");
*/
}


kkill(argc,argv)
int argc;
char **argv;
{
int i;
/*
   if(argv[1][0] == '-') 
      puts("Invalid signal\n");
   else
      while(++i < argc) 
         tkill(atoi(argv[i]));
*/
}

clearassoc(aptr)
struct assoctab *aptr;
{
   aptr->size = 0;
}

addassoc(aptr,str,fptr)
struct assoctab *aptr;
char *str;
int  (*fptr)();
{
struct rel_node *nptr;
   nptr = &aptr->rel[aptr->size++];
   nptr->str = str;
   nptr->fptr = fptr;
}

int (*getassoc(aptr,str))()
struct assoctab *aptr;
char *str;
{
register int n = 0;
   while(n<aptr->size) {
      if(strcmp(aptr->rel[n].str, str) == 0)
         return(aptr->rel[n].fptr);
      n++;
   }
   return(NULL); 
}

testalloc(argc,argv)
int argc;
char **argv;
{
/*
   printf("Allocating %d bytes\n",atoi(argv[1]));
   cflush();
   printf("Address: %x\n", kmalloc(atoi(argv[1])));
*/
}


testfree(argc,argv)
int argc;
char **argv;
{
/*
   printf("Freeing %x\n",atoi(argv[1]));
   cflush();
   kfree(atoi(argv[1]));
*/
}



setenv(env,attr,val)
ENVNODE **env;
char *attr;
char *val;
{
ENVNODE *eptr;
   while(*env && strcmp((*env)->name,attr) < 0)
      env = &((*env)->next);
   if(*env && strcmp((*env)->name,attr) == 0) {
      strcpy((*env)->val,val);
   } else {
      eptr = (ENVNODE*)malloc(sizeof(ENVNODE));
      strcpy(eptr->name,attr);
      strcpy(eptr->val,val);
      eptr->next = *env;
      *env = eptr;
   }
}

unsetenv(env,attr)
ENVNODE **env;
char *attr;
{
ENVNODE *eptr;
   while(*env && strcmp((*env)->name,attr) != 0)
      env = &((*env)->next);
   if (eptr = *env) {
      *env = (*env)->next;
      free(eptr);
   }
}

char *getenv(env,attr)
ENVNODE *env;
char *attr;
{
   while(env && strcmp(env->name,attr) != 0)
      env = env->next;
   if(env)
      return(env->val);
   return(NULL);
}


listenv(env)
ENVNODE *env;
{
   while(env) {
      printf("%-8s%s\n",env->name,env->val);
      env = env->next;
   }
}

kset(argc,argv)
int argc;
char **argv;
{
int i = 0;
   if(argc==1)
      listenv(env);
   else while(++i < argc) {
      if(i == argc-1 || strcmp(argv[i+1],"=") != 0)
         setenv(&env,argv[i],"");
      else {
         setenv(&env,argv[i],argv[i+2]);
         i += 2;
      }
   }
}


kunset(argc,argv)
int argc;
char **argv;
{
   unsetenv(&env,argv[1]);
}



glob(argc,argv,buf)
int argc;
char **argv;
char *buf;
{
int i = 0;
   while(i < argc) {
      strcat(buf,argv[i]);
      strcat(buf," ");
      i++;
   }
}

kalias(argc,argv)
int argc;
char **argv;
{
char buf[100];
   if(argc==1)
      listenv(alias);
   else if(argc==2)
      printf("%s\n",getenv(&alias,argv[1]));
   else {
      buf[0] = '\0';
      glob(argc-2,&argv[2],buf);
      setenv(&alias,argv[1],buf);
   }
}

kunalias(argc,argv)
int argc;
char **argv;
{
   unsetenv(&alias,argv[1]);
}



kmon(argc, argv)
	int argc;	
	char **argv;
{
	kadb();
}


kgtest(argc, argv)
	int argc;	
	char **argv;
{
char buf[256*256];
	gput(buf,atoi(argv[1]),atoi(argv[2]),256,256,atoi(argv[3]),
		atoi(argv[4]));
}


calljob(jorig)
struct job *jorig;
{
struct job j;
   j = *jorig;
   j.fptr(j.argc,j.argv,j.envtab);
   printf("\n[%d] Done  %s\n",j.jnum+1,jobcmd[j.jnum]);
   jobpid[j.jnum] = 0;
}



kshell(uname)
char *uname;
{
char buffer[160];
int i;  /* length of command string */
struct assoctab *cmdtab;
struct job j;
char *str;
char *argv[30];
int argnum,args;
uint32 oid,fid,oarg;
   printf("Entering kshell...\n");
   env = NULL;
   alias = NULL;
/*   cwd = root(); */
   strcpy(wdname,"/");
   setenv(&env,"host","fugazi");
   setenv(&env,"user","wrc");
   setenv(&env,"cwd","/");
   setenv(&env,"argv","()");
   setenv(&env,"status","0");
   setenv(&env,"path","(. /bin)");
   setenv(&env,"prompt","#");
   setenv(&env,"shell","ksh");
   setenv(&env,"home","/");
   setenv(&env,"history","20");
   setenv(&env,"term","vt100");
   setenv(&alias,"dir","ls -Flags");
   printf("Environment initialized\n");
   cmdtab = (struct assoctab*)malloc(sizeof(struct assoctab));
   for(i=0; i<MAXJOBS; i++)
      jobpid[i] = 0;
   kcmdhashall(cmdtab);
   clearassoc(&j.envtab);
   while(TRUE) {
      do {
         puts(getenv(env,"prompt"));
         i = creadline(buffer,78,'\n');
         if (i<0)
            puts("Use 'exit' to logout\n");
         args = argparse(buffer,argv,j.argbuf,1);	
      } while (args==0);
      argnum = 0;
      while(argnum < args) {
         j.argc = 0;
         while(argnum < args && strcmp(argv[argnum],";") != 0) {
            j.argv[j.argc++] = argv[argnum++];
         }
         j.argv[j.argc] = "";
         argnum++;
         while(str = getenv(alias,j.argv[0])) {
            strcpy(buffer,str);
            glob(j.argc-1,&j.argv[1],buffer);
            j.argc = argparse(buffer,j.argv,j.argbuf,1);
         }
         if(strcmp(j.argv[0],"exit") == 0) {
            puts("\nGoodbye cruel world\n");
            /* this now exits from the kernel */
            return(0);
         }
         j.fptr = getassoc(cmdtab, j.argv[0]);
         if(j.fptr) 
/*
            if(*j.argv[j.argc-1] == '&') {
               i=0;
               while(i<MAXJOBS && jobpid[i]) i++;
               if(i==MAXJOBS) 
                  puts("Too many jobs\n");
               else {
	          j.jnum = i;
                  strcpy(jobcmd[i],buffer);
                  j.argc--;
                  j.pid = tspawn(calljob,&j);
	          jobpid[i] = j.pid;
                  printf("[%d] %d\n",j.jnum+1,j.pid);
               }
            } else
*/
               j.fptr(j.argc,j.argv,j.envtab);
         else {
/*
            oid = kname(cwd,j.argv[0]);
            fid = F_INIT;
            oarg = 0;
            if(j.argc > 1) {
               fid = kname(cwd,j.argv[1]);
               if(j.argc > 2) {
                  oarg = kname(cwd,j.argv[2]);
               }
            }
            if (oid != ER_NOATTR) {
               if(oid<1024)
                   syscall(oid,fid,oarg);
               else
                   fcall(oid,fid,oarg);
            } else
*/
               printf("%s: Command not found\n", j.argv[0]);
         }
      }
   }
}


kcmdhashall(aptr)
struct assoctab *aptr;
{
   clearassoc(aptr);
   addassoc(aptr,"kill",kkill);
   addassoc(aptr,"blah",blah);
   addassoc(aptr,"fork",kfork);
   addassoc(aptr,"echo",kecho);
   addassoc(aptr,"jobs",kjobs);
   addassoc(aptr,"sleep",ksleep);
   addassoc(aptr,"ls",kls);
   addassoc(aptr,"mkdir",kmkdir);
   addassoc(aptr,"cd",kcd);
   addassoc(aptr,"cat",kcat);
   addassoc(aptr,"adb",kmon);
   addassoc(aptr,"kmon",kmon);
   addassoc(aptr,"alloc",testalloc);
   addassoc(aptr,"free",testfree);
   addassoc(aptr,"clear",kclear);
   addassoc(aptr,"link",klink);
   addassoc(aptr,"mail",kmail);
   addassoc(aptr,"Mail",kmail);
   addassoc(aptr,"rm",krm);
   addassoc(aptr,"ps",kps);
   addassoc(aptr,"vi",knotimp);
   addassoc(aptr,"fsck",knotimp);
   addassoc(aptr,"rlogin",knotimp);
   addassoc(aptr,"telnet",knotimp);
   addassoc(aptr,"rn",knotimp);
   addassoc(aptr,"cc",knotimp);
   addassoc(aptr,"su",knotimp);
   addassoc(aptr,"cp",knotimp);
   addassoc(aptr,"mv",kmv);
   addassoc(aptr,"man",knotimp);
   addassoc(aptr,"make",knotimp);
   addassoc(aptr,"who",kwho);
   addassoc(aptr,"w",kwho);
   addassoc(aptr,"finger",kfinger);
   addassoc(aptr,"pwd",kpwd);
   addassoc(aptr,"hostname",khostname);
   addassoc(aptr,"hostid",khostid);
   addassoc(aptr,"set",kset);
   addassoc(aptr,"unset",kunset);
   addassoc(aptr,"alias",kalias);
   addassoc(aptr,"unalias",kunalias);
   addassoc(aptr,"gtest",kgtest);
}
