/* mem_static
 *   static allocation of kernel structures, never to be freed
 */

#include "types.h"

extern int end();
#define align8(adr)	(adr)
#define align16(adr)	((adr+1) & ~1)
#define align32(adr)	((adr+3) & ~3)
#define align64(adr)	((adr+7) & ~7)


static uint32 smem_last;


uint32 smem_init()
{
	smem_last = align32((uint32)end);
}


uint32 smem_alloc(size)
	uint32 size;
{
uint32 adr;
	adr = smem_last;
	smem_last += align32(size);
	return(adr);
}



void smem_free(adr)
	uint32 adr;
{
}

