{ $IGraphics.Lib}

Const
  Xcenter= 200;
  Ycenter= 150;

Type
  xyz= (X,Y,Z);
  SineArr= ARRAY[0..511] of INTEGER;
  Point2D= ARRAY[1..256,x..y] of INTEGER;
  Vector3D= ARRAY[1..256,xyz] of INTEGER;
  Connect= ARRAY[1..512] of INTEGER;
  Rec3d= RECORD
    vec: ^Vector3D;
    con: ^Connect;
    numv,numc,
    xp,yp,zp,
    th,ph,ps: INTEGER End;
  FName= STRING[20];

Var
  ent: Rec3D;
  pnt,p2: Point2D;
  vec: Vector3D;
  lin: Connect;
  xv,yv,zv,numvec,numcon: INTEGER;
  sn: SineArr;
  sine: FILE;
  regpack: RECORD ax,bx,cx,dx,bp,si,di,ds,es,fl:INTEGER End;

Procedure SetUp3D(Var pnt:Point2D; xv,yv,zv,xc,yc:INTEGER);
Begin With regpack Do Begin
  es:=seg(pnt); bx:=ofs(pnt);
  ds:=seg(sn); si:=ofs(sn);
  ax:=xv; bx:=yv; cx:=zv; dx:=xc; di:=yc;
  regpack.bp:=0; Intr($46,regpack)
End End;

Procedure ComputeVectors(Var ent: Rec3D; xp,yp,zp,th,ph,ps:INTEGER);
Begin
  ent.xp:=xp; ent.yp:=yp; ent.zp:=zp;
  ent.th:=th; ent.ph:=ph; ent.ps:=ps;
  regpack.ds:=seg(ent); regpack.si:=ofs(ent);
  regpack.bp:=1; Intr($46,regpack)
End;

Procedure InitSinTable;
Begin
  Assign(sine,'SINE.DAT'); Reset(sine); BlockRead(sine,sn,8)
End;

Procedure LoadShape(fn: FNAME);
Var
  I: INTEGER;
  f: FILE of INTEGER;
Begin
  Assign(f,fn+'.BIN');
  Reset(f);
  Read(f,numvec,numcon);
  For I:= 1 to numvec Do Read(f,vec[I,x],vec[I,y],vec[I,z]);
  For I:= 1 to numcon Do Read(f,lin[I])
End;

Var
  status,video,I,xp,yp: INTEGER;
Begin
  InitSinTable;
  For I:=0 to 1 Do Begin
    vec[1+I*4,x]:=-1; vec[1+I*4,y]:=-1; vec[1+I*4,z]:=-1+2*I;
    vec[2+I*4,x]:=1; vec[2+I*4,y]:=-1; vec[2+I*4,z]:=-1+2*I;
    vec[3+I*4,x]:=1; vec[3+I*4,y]:=1; vec[3+I*4,z]:=-1+2*I;
    vec[4+I*4,x]:=-1; vec[4+I*4,y]:=1; vec[4+I*4,z]:=-1+2*I
   End;
  ent.vec:=addr(vec); ent.con:=addr(lin);
  ent.numv:=8; ent.numc:=1;
  {ClrScr; InitGR(status,video);
  SetGr(3,4); SetBG($FFFF); }
  xv:= 0; yv:= 0; zv:= -300; I:= 0; xp:= 0; yp:= 0;
  SetUp3D(pnt,xv,yv,zv,200,150);
  pnt[1,x]:=1; pnt[1,y]:=2; pnt[2,x]:=3; pnt[2,y]:=4;
  ComputeVectors(ent,0,0,8000,0,0,0);
  {Repeat
    ComputeVectors(pnt,vec,sn,scratch,numvec,I,I*2,0,xv,yv,zv,xp,yp+40,1000-I,
      xcenter,ycenter); I:= I + 5;
    SetBG(0); PlotPoly(pnt,lin,numcon);
  Until KeyPressed}
  Writeln(pnt[1,x],' ',pnt[1,y],' ',pnt[2,x],' ',pnt[2,y])
End.