
#include <math.h>


static int WID = 1536;
static int HGT = 1152;


#define RES 64 

int rnd(range)
	int range;
{
static int seed;
int n;
	seed = seed * 357893123 - 98452477;
	n = ((seed & 0x7fffffff) % range);
	return(n);
}


stars(count,speed)
	int count, speed;
{
int x[1000], y[1000];
int vx[1000], vy[1000];
int i;
	for(i=0; i<1000; i++) {
		x[i] = WID*RES/2;
		y[i] = HGT*RES/2;
		vx[i] = rnd(RES*32) - RES*16;
		vy[i] = rnd(RES*32) - RES*16;
	}
	gclear(0,0,WID,HGT);
	while(!unblank()) {
		i = (i+1) % count;
		gline(x[i]/RES,y[i]/RES,x[i]/RES,y[i]/RES,0,0x0000);
		x[i] += vx[i];
		y[i] += vy[i];
		vx[i] = (vx[i]*1000)/900; 
		vy[i] = (vy[i]*1000)/900; 
		if(x[i] < 0 || x[i] > WID*RES 
			|| y[i] < 0 || y[i] > HGT*RES
			|| (vx[i] == 0 && vy[i] == 0)) {
			x[i] = WID*RES/2;
			y[i] = HGT*RES/2;
			vx[i] = rnd(RES*speed*2) - RES*speed;
			vy[i] = rnd(RES*speed*2) - RES*speed;
		}	
		gline(x[i]/RES,y[i]/RES,x[i]/RES,y[i]/RES,0,0xffff);
	}
}



design(num, len)
	int num, len; 
{
int i;
int n;
int sx[100][100], sy[100][100];
int x[100],y[100],vx[100],vy[100];
char ch;
	for(i=0; i<num*2; i++) {
	 	x[i] = WID*RES/2;
		y[i] = HGT*RES/2;
		vx[i] = 0;
		vy[i] = 0;
		for(n=0; n<len; n++) {
			sx[i][n] = 0;
			sy[i][n] = 0;
		}
	}
	n = 0;
	gclear(0,0,WID,HGT);
	while(1) { 
          for(i=0; i<num*2; i++) {
		vx[i] += (rnd(RES/2+1) - RES/4);
		vy[i] += (rnd(RES/2+1) - RES/4);
		if (vx[i] > RES*20)
			vx[i] = RES*20;
		if (vx[i] < -RES*20)
			vx[i] = -RES*20;
		if (vy[i] > RES*20)
			vy[i] = RES*20;
		if (vy[i] < -RES*20)
			vy[i] = -RES*20;
		x[i] += vx[i];
		y[i] += vy[i];
		if (x[i] < 0) 
			{ x[i] = 0; if (vx[i] < 0) vx[i] = -vx[i]; }
		if (y[i] < 0) 
			{ y[i] = 0; if (vy[i] < 0) vy[i] = -vy[i]; }
		if (x[i] > WID*RES-1) 
			{ x[i] = WID*RES-1; if (vx[i] > 0) vx[i] = -vx[i]; }
		if (y[i] > HGT*RES-1) 
			{ y[i] = HGT*RES-1; if (vy[i] > 0) vy[i] = -vy[i]; }
	} for(i=0; i<num*2; i += 2) {
		gline(sx[i][n], sy[i][n], sx[i+1][n], sy[i+1][n], 0, 0x0000);
		sx[i][n] = x[i]/RES; sy[i][n] = y[i]/RES;
		sx[i+1][n] = x[i+1]/RES; sy[i+1][n] = y[i+1]/RES;
		gline(sx[i][n], sy[i][n], sx[i+1][n], sy[i+1][n], 0, 0xffff);
		if(unblank())
			return;
	  } 
	  n = (n+1) % len;
	}
}





static double trek_pdat[] = {
	0.1, -0.1, 0.1, 0.1, 0.1, 0.1, -0.1, 0.1, 0.1, -0.1, -0.1, 0.1,
	0.1, -0.1, -1.0, -0.1, -0.1, -1.0, -0.1, 0.1, -0.9, 0.1, 0.1, -0.9,
	-0.08, -0.1, -0.5, -0.08, -0.1, -0.4, -0.5, -0.8, -1.0, -0.5, -0.8,
	-0.8, 0.08, -0.1, -0.5, 0.08, -0.1, -0.4, 0.5, -0.8, -1.0, 0.5,
	-0.8, -0.8,	
	-0.45,-0.8,-0.3,-0.45,-1.0,-0.25,-0.55,-1.0,-0.25,-0.55,-0.8,-0.3,
	-0.45,-0.8,-1.4,-0.55,-0.8,-1.4,-0.55,-1.0,-1.5,-0.45,-1.0,-1.5,
	0.45,-0.8,-0.3,0.45,-1.0,-0.25,0.55,-1.0,-0.25,0.55,-0.8,-0.3,0.45,
	-0.8,-1.4,0.55,-0.8,-1.4,0.55,-1.0,-1.5,0.45,-1.0,-1.5,
	0.0,-0.1,0.1,0.0,-0.2,0.1,0.0,-0.45,0.4,0.0,-0.5,-0.1,0.0,-0.1,-0.4,
	0.4,-0.5,-0.1,0.8,-0.5,0.3,0.8,-0.5,1.1,0.4,-0.5,1.5,-0.4,-0.5,1.5,
	-0.8,-0.5,1.1,-0.8,-0.5,0.3,-0.4,-0.5,-0.1,
	0.0,-0.5,0.4,0.0,-0.5,1.0,0.3,-0.5,0.7,-0.3,-0.5,0.7,0.0,-0.6,0.7,
	0.0,-0.45,0.7
};

static short trek_sdat[] = {
	4,1,2,3,4,6,5,8,2,-1,8,7,3,-1,6,7,-1,5,1,-1,
	9,10,12,11,9,-1,13,14,16,15,13,-1,
	20,17,18,19,20,22,21,24,18,-1,24,23,19,-1,22,23,-1,21,17,-1,
	28,25,26,27,28,30,29,32,26,-1,32,31,27,-1,30,31,-1,29,25,-1,
	33,34,35,36,37,33,-1,
	38,39,40,41,42,43,44,45,38,-1,
	46,50,47,51,46,-1,48,50,49,51,48,-1,
};


static double csh_pdat[] = {
	-0.9,0.8,0.1,
	0.4,0.8,0.1,
	0.4,0.5,0.1,
	0.2,0.5,0.1,
	0.2,0.6,0.1,
	-0.7,0.6,0.1,
	-0.7,-0.6,0.1,
	0.2,-0.6,0.1,
	0.2,-0.5,0.1,
	0.4,-0.5,0.1,
	0.4,-0.8,0.1,
	-0.9,-0.8,0.1,
	
	-0.6,0.5,0.1,
	0.1,0.5,0.1,
	0.1,0.2,0.1,
	-0.1,0.2,0.1,
	-0.1,0.3,0.1,
	-0.4,0.3,0.1,
	-0.4,0.1,0.1,
	0.1,0.1,0.1,
	0.1,-0.5,0.1,
	-0.6,-0.5,0.1,
	-0.6,-0.2,0.1,
	-0.4,-0.2,0.1,
	-0.4,-0.3,0.1,
	-0.1,-0.3,0.1,
	-0.1,-0.1,0.1,
	-0.6,-0.1,0.1,
	
	0.2,0.4,0.1,
	0.4,0.4,0.1,
	0.4,0.1,0.1,
	0.7,0.1,0.1,
	0.7,0.6,0.1,
	0.9,0.6,0.1,
	0.9,-0.6,0.1,
	0.7,-0.6,0.1,
	0.7,-0.1,0.1,
	0.4,-0.1,0.1,
	0.4,-0.4,0.1,
	0.2,-0.4,0.1

	-0.9,0.8,-0.1,
	0.4,0.8,-0.1,
	0.4,0.5,-0.1,
	0.2,0.5,-0.1,
	0.2,0.6,-0.1,
	-0.7,0.6,-0.1,
	-0.7,-0.6,-0.1,
	0.2,-0.6,-0.1,
	0.2,-0.5,-0.1,
	0.4,-0.5,-0.1,
	0.4,-0.8,-0.1,
	-0.9,-0.8,-0.1,
	
	-0.6,0.5,-0.1,
	0.1,0.5,-0.1,
	0.1,0.2,-0.1,
	-0.1,0.2,-0.1,
	-0.1,0.3,-0.1,
	-0.4,0.3,-0.1,
	-0.4,0.1,-0.1,
	0.1,0.1,-0.1,
	0.1,-0.5,-0.1,
	-0.6,-0.5,-0.1,
	-0.6,-0.2,-0.1,
	-0.4,-0.2,-0.1,
	-0.4,-0.3,-0.1,
	-0.1,-0.3,-0.1,
	-0.1,-0.1,-0.1,
	-0.6,-0.1,-0.1,
	
	0.2,0.4,-0.1,
	0.4,0.4,-0.1,
	0.4,0.1,-0.1,
	0.7,0.1,-0.1,
	0.7,0.6,-0.1,
	0.9,0.6,-0.1,
	0.9,-0.6,-0.1,
	0.7,-0.6,-0.1,
	0.7,-0.1,-0.1,
	0.4,-0.1,-0.1,
	0.4,-0.4,-0.1,
	0.2,-0.4,-0.1
};

static short csh_sdat[] = {
	1,2,3,4,5,6,7,8,9,10,11,12,1,-1,
	13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,13,-1,
	29,30,31,32,33,34,35,36,37,38,39,40,29,-1,
	1,41,-1,
	2,42,-1,
	3,43,-1,
	4,44,-1,
	5,45,-1,
	6,46,-1,
	7,47,-1,
	8,48,-1,
	9,49,-1,
	10,50,-1,
	11,51,-1,
	12,52,-1,
	13,53,-1,
	14,54,-1,
	15,55,-1,
	16,56,-1,
	17,57,-1,
	18,58,-1,
	19,59,-1,
	20,60,-1,
	21,61,-1,
	22,62,-1,
	23,63,-1,
	24,64,-1,
	25,65,-1,
	26,66,-1,
	27,67,-1,
	28,68,-1,
	29,69,-1,
	30,70,-1,
	31,71,-1,
	32,72,-1,
	33,73,-1,
	34,74,-1,
	35,75,-1,
	36,76,-1,
	37,77,-1,
	38,78,-1,
	39,79,-1,
	40,80,-1, 
	41,42,43,44,45,46,47,48,49,50,51,52,41,-1,
	53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,53,-1,
	69,70,71,72,73,74,75,76,77,78,79,80,69,-1 
};

trek(pic, xxx, yyy, wid, hgt)
	int pic, xxx, yyy, wid, hgt;
{
register int i;
register int x;
int numv, numc;
int xpnt[200], ypnt[200];
double sx,sy,sz;
double theta,phi,psi;
double xp,yp,zp;
double xv,yv,zv;
int xctr, yctr;
double xpos,ypos;
double cp,sp,ct,st,cs,ss;
double *pdat;
short *sdat;
char ch;
	if (pic == 0) {
		pdat = csh_pdat;
		sdat = csh_sdat;
		numv = sizeof(csh_pdat)/sizeof(double)/3;
		numc = sizeof(csh_sdat)/sizeof(short);
	} else {	
		pdat = trek_pdat;
		sdat = trek_sdat;
		numv = sizeof(trek_pdat)/sizeof(double)/3;
		numc = sizeof(trek_sdat)/sizeof(short);
	}
	WID = wid;
	HGT = hgt;
	sx = 50.0;
	sy = 50.0;
	sz = 50.0;
	xp = 0.0;
	yp = 0.0;
	zp = -200.0;
	xv = 0.0;
	yv = 0.0;
	zv = 200.0;	
	xctr = WID/2;
	yctr = HGT/2;
	theta = 0.0;
	phi = 0.0;
	psi = 0.0;
	gclear(xxx,yyy,WID,HGT);
	x = 0;
	while(1) {
		if(unblank())
			return;
		cp = cos(phi);
		sp = sin(phi);
		ct = cos(theta);
		st = sin(theta);
		cs = cos(phi);
		ss = sin(phi);
		for(i=1; i< (numv+1); i++) {
			calc3d(&xpos, &ypos, 
				pdat[i*3-3]*sx,
				pdat[i*3-2]*sy,
				pdat[i*3-1]*sz,
				xp,yp,zp,
				xv,yv,zv,
				cp,sp,ct,st,cs,ss);
			xpnt[i] = (int)xpos + xctr;
			ypnt[i] = (int)ypos + yctr;
		}
		for(i=1; i<numc; i++) {
			if (sdat[i] != -1 && sdat[i-1] != -1)  {
				clipline(xpnt[sdat[i-1]],ypnt[sdat[i-1]],
					xpnt[sdat[i]],ypnt[sdat[i]]);
			}
		}
		gclear(xxx,yyy,WID,HGT);
		zp += 2.0;
		theta += 0.4;
		phi += 0.20;
		psi += 0.10;
		if (zp > 400.0)
			zp = -400.0;
	}
}



calc3d(xpos, ypos, xp, yp, zp, xc, yc, zc, xv, yv, zv, cp, sp, ct, st, cs, ss)
	double *xpos, *ypos;
	double xp, yp, zp, xc, yc, zc, xv, yv, zv;
	double cp,sp,ct,st,cs,ss;
{
double xct, yct, zsp, xst, yst, zcp, xctsp, ystsp, xt, yt, zt;
	xct = xp*ct;
	yct = yp*ct;
	zsp = zp*sp;
	xst = xp*st;
	yst = yp*st;
	zcp = zp*cp;
	xctsp = xct*sp;
	ystsp = yst*sp;
	xt = xct*cp-yst*cp+zsp+xc;
	yt = xctsp*ss+xst*cs-ystsp*ss+yct*cs-zcp*ss+yc;
	zt = xst*ss-xctsp*cs+ystsp*cs+yct*ss+zcp*cs+zc;
	*xpos = (xt+zt*(xt-xv)/(zv-zt));
	*ypos = (yt+zt*(yt-yv)/(zv-zt));
}


clipline(x1, y1, x2, y2)
	int x1, y1, x2, y2;
{
int xmin, xmax, ymin, ymax;
double m;
xmin = 0;
ymin = 0;
xmax = HGT-1;
ymax = WID-1;
	if( x1 < xmin && x2 < xmin)
		return;
	if( x1 > xmax && x2 > xmax)
		return;
	if( y1 < ymin && y2 < ymin)
		return;
	if( y1 > ymax && y2 > ymax)
		return;
	if (x2 == x1) {
		if (y1 < ymin)
			y1 = ymin;
		else if (y1 > ymax)
			y1 = ymax;
		if (y2 < ymin)
			y2 = ymin;
		else if (y2 > ymax)
			y2 = ymax;
		gline(x1,y1,x2,y2,0,0xffff);
		return;
	} 
	if (y2 == y1) {
		if (x1 < xmin)
			x1 = xmin;
		else if (x1 > xmax)
			x1 = xmax;
		if (x2 < xmin)
			x2 = xmin;
		else if (x2 > xmax)
			x2 = xmax;
		gline(x1,y1,x2,y2,0,0xffff);
		return;
	}
	m = (double)(y2 - y1) / (double)(x2 - x1);
	if( x1 < xmin) {
		y1 = m*(double)(xmin-x1) + y1;
		x1 = xmin;
	} else
	if( x1 > xmax) {
		y1 = m*(double)(xmax-x1) + y1;
		x1 = xmax;
	}
	if( x2 < xmin) {
		y2 = m*(double)(xmin-x2) + y2;
		x2 = xmin;
	} else
	if( x2 > xmax) {
		y2 = m*(double)(xmax-x2) + y2;
		x2 = xmax;
	}
	if( y1 < ymin) {
		x1 = (double)(ymin-y1)/m + x1;
		y1 = ymin;
	} else
	if( y1 > ymax) {
		x1 = (double)(ymax-y1)/m + x1;
		y1 = ymax;
	}
	if( y2 < ymin) {
		x2 = (double)(ymin-y2)/m + x2;
		y2 = ymin;
	} else
	if( y2 > ymax) {
		x2 = (double)(ymax-y2)/m + x2;
		y2 = ymax;
	}
	if (y1 < ymin || y1 > ymax || x1 < xmin || x1 > xmax)
		return;
	if (y2 < ymin || y2 > ymax || x2 < xmin || x2 > xmax)
		return;
	gline(x1, y1, x2, y2, 0, 0xffff);
}





