#include <stdio.h>


static long base;


typedef struct asm_struct {
	int	addr;	
	char	cmd[15];
	char	used;
	char	*arg;
	struct asm_struct *next;
} Asm;



Asm *alist;


int adr_stack[4000];
int adr_stack_n = 0;


main(argc, argv)
	int argc;
	char **argv;
{
FILE *f1;
int adr;
	f1 = fopen(argv[1], "r");
	adr = strtol(argv[2], NULL, 16);
	base = adr & 0xffff0000;
	read_asm(f1, base);
	fclose(f1);
	printf("Read in %s\n", argv[1]);
	push_adr(adr);
	while(adr_stack_n) {
		adr = pop_adr();
		printf("\n****** Trace at %x:\n", adr);
		trace_asm(adr);
	}
	printf("Done\n");
}



push_adr(adr)
	int adr;
{
	adr_stack[adr_stack_n++] = adr;
}


int pop_adr()
{
	return( adr_stack[--adr_stack_n] );
}



read_asm(f1, base)
	FILE *f1;
	int base;
{
char buf[256];
Asm *np, **lp;
char *bp;
int i;
int oldaddr;
	alist = NULL;
	lp = &alist;
	oldaddr = base;
	while(!feof(f1)) {
		fgets(buf, 256, f1);
		np = (Asm*)malloc(sizeof(Asm));
		if (buf[0] <= ' ') {
			np->addr = ++oldaddr;
			strcpy(np->cmd, "   case: ");
			bp = buf;
		} else {
			np->addr = base + strtol(buf, &bp, 16);
			oldaddr = np->addr;
			while(*bp == ':' || *bp <= ' ')
				bp++;
			i = 0;
			while(*bp > ' ')
				np->cmd[i++] = *bp++;
			np->cmd[i] = '\0';
		}
		bp[strlen(bp)-1] = '\0';
		np->arg = (char*)strdup(bp);	
		np->used = 0;
		np->next = NULL;
		*lp = np;
		lp = &((*lp)->next);
	}	
}




Asm *find_addr(addr)
	int addr;
{
Asm *ap;
	ap = alist;
	while (ap && ap->addr < addr) {
		ap = ap->next;
	}
	if (!ap || ap->addr != addr) {
		printf("\nAddress %x not found\n", addr);
		exit(1);
	}
	return(ap);	
}



int value(str)
	char *str;
{
int i;
char *tp;
	while((*str < '0' || *str > '9') && (*str < 'a' || *str > 'f'))		
		str++;
	tp = str;
	--tp;
	if (tp[0] == '*')
		return(0);
	i = strtol(str, NULL, 16);
	if (i < 0x100000)
		i += base;
	return(i);
}


int value_end(str)
	char *str;
{
int i;
	str += strlen(str);
	while(*str != ',')
		str--;
	return(value(str));
}
	


trace_asm(addr)
	int addr;
{
int i;
Asm *ap, *np;
	printf("----> %x\n", addr);
	ap = find_addr(addr);
	while(1) {	
		print_asm(ap);
		ap->used = 1;
		if (strcmp(ap->cmd, "halt") == 0) {
			printf("*** halt ***\n");
			break;
		} else if (  strcmp(ap->cmd, "rsb") == 0
			|| strcmp(ap->cmd, "ret") == 0) {
			break;
		} else if (  strcmp(ap->cmd, "brb") == 0
			|| strcmp(ap->cmd, "brw") == 0
			|| strcmp(ap->cmd, "jmp") == 0) {
			np = find_addr(value(ap->arg));
			if (np->used) {
				printf("    ---> loop: %x\n", np->addr);
				break;
			} else
				ap = np;
		} else if (  strcmp(ap->cmd, "calls") == 0
			|| strcmp(ap->cmd, "callg") == 0) {
			i = value_end(ap->arg);
			if (!i) {
				printf("    ---> variable call\n");
				ap = ap->next;
				continue;
			}
			np = find_addr(i);
			if (np->used)
				printf("    ---> sub: %x\n", np->addr);
			else
				trace_asm(np->addr);
			ap = ap->next;	
		} else if (  strcmp(ap->cmd, "jsb") == 0
			|| strcmp(ap->cmd, "bsbw") == 0
			|| strcmp(ap->cmd, "bsbb") == 0) {
			i = value(ap->arg);
			if (!i) {
				printf("    ---> variable call\n");
				ap = ap->next;
				continue;
			}
			np = find_addr(i);
			if (np->used)
				printf("    ---> sub: %x\n", np->addr);
			else
				trace_asm(np->addr);
			ap = ap->next;	
		} else if (  strcmp(ap->cmd, "beql") == 0
			|| strcmp(ap->cmd, "bneq") == 0
			|| strcmp(ap->cmd, "bgtr") == 0
			|| strcmp(ap->cmd, "blss") == 0
			|| strcmp(ap->cmd, "bcc") == 0
			|| strcmp(ap->cmd, "bcs") == 0
			|| strcmp(ap->cmd, "bgeq") == 0
			|| strcmp(ap->cmd, "bgequ") == 0
			|| strcmp(ap->cmd, "bgtru") == 0
			|| strcmp(ap->cmd, "bleq") == 0
			|| strcmp(ap->cmd, "blequ") == 0
			|| strcmp(ap->cmd, "blssu") == 0
			|| strcmp(ap->cmd, "bnequ") == 0
			|| strcmp(ap->cmd, "bvc") == 0
			|| strcmp(ap->cmd, "bvs") == 0
			|| strcmp(ap->cmd, "beqlu") == 0) {
			np = find_addr(value(ap->arg));
			if (np->used)
				printf("    ---> ? loop: %x\n", np->addr);
			else
				push_adr(np->addr);
			ap = ap->next;
		} else if (  strcmp(ap->cmd, "bbc") == 0
			|| strcmp(ap->cmd, "bbcc") == 0
			|| strcmp(ap->cmd, "bbcs") == 0
			|| strcmp(ap->cmd, "bbs") == 0
			|| strcmp(ap->cmd, "bbsc") == 0
			|| strcmp(ap->cmd, "bbss") == 0
			|| strcmp(ap->cmd, "blbc") == 0
			|| strcmp(ap->cmd, "blbs") == 0
			|| strcmp(ap->cmd, "bbss") == 0) {
			np = find_addr(value_end(ap->arg));
			if (np->used)
				printf("    ---> ? loop: %x\n", np->addr);
			else
				push_adr(np->addr);
			ap = ap->next;
		} else 
			ap = ap->next;
	}
	printf("<---- return\n");
}


list_asm(addr, count)
	int addr;
	int count;
{
Asm *ap;
	ap = find_addr(addr);
	while(ap && count--) {
		print_asm(ap);
		ap = ap->next;
	}
}


print_asm(ap)
	Asm *ap;
{
	printf("%8x: %-10s %s\n", ap->addr, ap->cmd, ap->arg);
}


	

