#define SOH 1
#define EOT 4
#define ACK 6
#define NAK 21
#define CAN 24
#define XON  17
#define XOFF 19
#define CTRLZ 26





/* serial put character: */
void sputc(line, ch)
	int line;
	char ch;
{
	serial_write(line, &ch, 1);
}


xmodem_receive(line, addr)
	int line;
	unsigned int addr;
{
unsigned char buf[300];
int i;
unsigned int blk;
	blk = 1;
	while(1) {
		xmodem_getblock(line, buf);
		if (buf[0] == 'b')  {
			return(uu_receive(line, addr));
		}
		if (buf[0] == EOT) {
			sputc(line, ACK);
			break;
		}
		if (buf[0] == CAN)
			return(-1);
		if (buf[0] == SOH && buf[131] == buf[132] ) {
			if (buf[1] == (blk & 0xff)
			    && buf[1] == (buf[2] ^ 0xff)) {
				for(i=0; i<128; i++)
					*(char*)addr++ = buf[i+3]; 
				blk++;
				sputc(line, ACK);
				con_putc('#');
			} else if (buf[1] == ((blk-1) & 0xff) 
			    && buf[1] == (buf[2] ^ 0xff)) {
				sputc(line, ACK);
				con_putc('#');
			} else {
				sputc(line, NAK);
				con_putc('1');
			}
		} else {
			sputc(line, NAK);
			con_putc('2');
		}
	}
	return(0);
}

xmodem_getblock(line, buf)
	int line;
	unsigned char *buf;
{
int i;
unsigned int chk;
int wait = 0;
	while (serial_read(line, buf, 1) == 0)  {
		con_putc("/-\|"[wait = (wait+1)&3]);
		con_putc(8);
		sputc(NAK);
	}
	if (buf[0] != SOH) {
		return;
	}
	if ((i=serial_read(line, &buf[1], 131)) != 131)  {
		buf[0] = NAK;
	}
	if (serial_read(line, &buf[132], 140) != 0) {
		buf[0] = NAK;
	}
	chk = 0;
	for(i = 3; i < 131; i++)
		chk += buf[i];
	buf[132] = chk;
}


unsigned char uu_getch(line)
	int line;
{
unsigned char ch;
	do {
		while(serial_read(line, &ch, 1) == 0)
			continue;
	} while (ch < 0x20 || ch > 0x60);
	return((ch - 0x20) & 0x3f);
}


uu_receive(line, addr)
	int line;
	int addr;
{
int base;
char ch;
int len;
int i;
unsigned char b1,b2,b3,b4;
unsigned long d;
	con_printf("\r\n");
	base = addr;
	do {
		while(serial_read(line, &ch, 1) == 0)
			continue;
	} while (ch != '\n' && ch != '\r');
	do {
		len = uu_getch(line);
		for(i=0; i<len; i += 3) {
			b1 = uu_getch(line);
			b2 = uu_getch(line);
			b3 = uu_getch(line);
			b4 = uu_getch(line);
			d = (b1 << 18) | (b2 << 12) | (b3 << 6) | b4;
			*(char*)addr++ = (d >> 16) & 0xff;
			*(char*)addr++ = (d >> 8) & 0xff;
			*(char*)addr++ = d & 0xff;
		}
		con_printf("\r%8x %d", addr, addr-base);
	} while(len);
	return(0);
}


xm_uu_download()
{
register unsigned long line;	/* r11 */
register unsigned long addr;	/* r10 */
int adsave;
int i;
long *s;
	adsave = addr;
	if (xmodem_receive(line, adsave) < 0)
		return;
	addr = adsave;
	addr += 2;
	if (*(long*)addr)
		asm("jmp (r10)");
}

